<?php

class lgtv {
  var $ip = '';
  var $port = 8080;
  var $httpCode = 0;

  function GetData($path, $xml){
	$http = curl_init();
	curl_setopt_array($http, 
		array(
			CURLOPT_URL => 'http://'.$this->ip.':'.$this->port.$path,
			CURLOPT_RETURNTRANSFER => true,
			CURLOPT_POST => true,
			CURLOPT_POSTFIELDS => $xml,
			CURLOPT_HTTPHEADER => array(
				'Content-Type: text/xml; charset=utf-8',
				'Cache-Control: no-cache',
				'Connection: Keep-Alive'
			),
			CURLOPT_USERAGENT => 'User-Agent: Linux/2.6.18 UDAP/2.0 CentOS/5.8'
		)
	);

	$res = curl_exec($http);
	//echo '|'.print_r( $res, true ).'|';
	
	$this->httpCode = curl_getinfo($http, CURLINFO_HTTP_CODE);
	curl_close($http);	
	
	return $res;
  }
  
  function RequestPairingKey(){
    $xml = '<?xml version="1.0" encoding="utf-8"?><envelope><api type="pairing"><name>showKey</name></api></envelope>';
	$this->GetData('/udap/api/pairing', $xml);	
	return $this->httpCode == 200;
  }
  
  function RequestPairing($key){
    $xml = '<?xml version="1.0" encoding="utf-8"?><envelope><api type="pairing"><name>hello</name><value>'.$key.'</value><port>8080</port></api></envelope>';
	$this->GetData('/udap/api/pairing', $xml);	
	return $this->httpCode == 200;
  }
  
  function EndPairing(){
    $xml = '<?xml version="1.0" encoding="utf-8"?><envelope><api type="pairing"><name>byebye</name><port>8080</port></api></envelope>';
	$this->GetData('/udap/api/pairing', $xml);	
	return $this->httpCode == 200;
  }
  
  function Command($name, $value){
    $xml = '<?xml version="1.0" encoding="utf-8"?><envelope><api type="command"><name>'.$name.'</name><value>'.$value.'</value></api></envelope>';
	return $this->GetData('/udap/api/command', $xml);
  }
  
  function Query($query){
	return $this->GetData('/udap/api/data', http_build_query( array('target' => 'volume_info')) );
  }
  
}

?>